import javacardx.framework.*;
import javacard.framework.*;
import sim.toolkit.*;

public class Input extends Page implements GSMCharacter, ST, Constant {

  final static short MAX_TEXT_LENGTH   = (short) 32;
  final static short MAX_ANSWER_LENGTH = (short) 30;
  final static byte  INPUTCMD = (byte) 0x04;

  ProactiveElement textString;
  ProactiveElement responseLength;

  public byte bMode;
  public byte[] bAnswer = new byte[MAX_ANSWER_LENGTH];
  public byte bLength;

	public Input() {
  }

  public void setText( byte[] titleText, short start, short len, byte bmMode){
    if (textString == null){
      textString = new ProactiveElement(TEXT_STRING_TAG, (short) MAX_TEXT_LENGTH);
      APDU.waitExtension();
      textString.tlv[2]=(byte)0xF4;
    }
    if (responseLength == null){
      responseLength = new ProactiveElement(RESPONSE_LENGTH_TAG, (short) 2);
      APDU.waitExtension();
      // Set the minimum length of the input
      responseLength.tlv[2] = (byte)0x00;
      // Set the maximum length of the input
		  responseLength.tlv[3] = (byte) MAX_ANSWER_LENGTH;
    }
    bMode = bmMode;

    Util.arrayCopyNonAtomic(titleText, (short)start,
                            textString.tlv, (short)3, (short)(len - (short)1));
    textString.setLength( (short) len  );
  }

  public byte buildCommand() {
    ProactiveCommand.getInput((byte)INPUTCMD, bMode,
                               textString, responseLength );
    return ST.SUCCESS;
  }

	public Page processResponse(){
		Page returnPage;
		returnPage = super.processResponse();
    if( ProactiveCommand.manageGeneralResult() == ST_SUCCESS) {
        bLength = ProactiveCommand.getText(bAnswer, (short)0);
    }
    return (returnPage);
	}
}

