// creates the menu on the mobile and handles the interaction when
// you use the menu instead of a sms

import javacard.framework.*;
import javacardx.framework.*;
import sim.toolkit.*;

public class Menu extends Page implements Action, GSMCharacter, Constant {

    WebSIM webSim;

    short counter, itemCounter, start, len;
    short textLength;
    byte[] itemText = new byte[64];
    byte[] bReq = new byte[64];

    static final byte RESTART_SELECT_REQUEST      = (byte) 0x01;
    static final byte RESTART_EXIT                = (byte) 0x02;
    static final byte RESTART_BASH                = (byte) 0x03;
    static final byte RESTART_URL                 = (byte) 0x04;
    static final byte RESTART_REQUEST             = (byte) 0x05;
    static final byte RESTART_SMSDOWNLOAD         = (byte) 0x06;

    static final byte CHAR_HASH          = (byte)0x23;


    public Menu() {
      APDU.waitExtension();
    }

    public void process( WebSIM webSim) {
      this.webSim = webSim;

      webSim.currentPage = webSim.menu;
      webSim.pushAction( this, RESTART_SELECT_REQUEST );
      APDU.waitExtension();

      if (buildCommand()== ST_SUCCESS){
        ProactiveCommand.executeCommand();
      }
    }

    public byte buildCommand() {
      ProactiveCommand.selectItem( webSim.selectItem.SELECTCMD,   // command number
                                 (byte)0,     // no help available
                                 // FIXME: title seems to be buggy im ME simulator
                                 null, //title,
                                 webSim.menuItem);      // items to be displayed
      return ST.SUCCESS;
    }

    public Page processResponse(){
      byte itemID;
		  Page returnPage;
		  returnPage = super.processResponse();
      itemText[0] = (byte) 0xFF;     // indicates an error
      if( ProactiveCommand.manageGeneralResult() == ST_SUCCESS) {
        itemID = ProactiveCommand.getItemIdentifier();
        //copy tlv into buffer, so we can use it in the restart methode
        Util.arrayCopyNonAtomic(webSim.menuItem[(short)itemID].tlv, (short)0,
                                    itemText, (short)0,
                                    (short)(webSim.menuItem[(short)itemID].getLength()+(short)2)) ;
      }
      return (returnPage);
	  }

     public void restart( WebSIM webSim, byte restartAction ) {

      switch( restartAction ) {

        case RESTART_SELECT_REQUEST:
          //webSim.displayMessage.open();
          //APDU.waitExtension();
          //webSim.pushAction( this, RESTART_EXIT );
          //textLength = (short)(itemText[1]-(short)1);
          //Util.arrayCopyNonAtomic(itemText,(short)2,itemText,(short)0,textLength);
          //webSim.displayMessage.writeMessage(itemText,(short)0, textLength);
          APDU.waitExtension();
          //webSim.displayMessage.writeShortHex(textLength);
          //webSim.displayMessage.writeByte((byte) 'A');
          /*
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(itemText[0]);
          webSim.displayMessage.writeByteHex(itemText[1]);
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(itemText[2]);
          webSim.displayMessage.writeByteHex(itemText[3]);
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(itemText[4]);
          webSim.displayMessage.writeByteHex(itemText[5]);
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(itemText[9]);
          APDU.waitExtension();
          //webSim.displayMessage.writeByte(itemText[6]);

          webSim.pushAction( this, RESTART_EXIT );
          if (webSim.displayMessage.buildCommand()== ST_SUCCESS){
            ProactiveCommand.executeCommand();
          }
          */
          // parses the menu selection
          // the menu structur is "hard coded"
          // the menu has to look like: About
          //                            Enter Request
          //                            Enter URL
          //                            Enter Bash
          // if you change the menu, you have to change the if clauses
          if (itemText[2] != (byte) 0xFF) {
            switch( itemText[2] ) {

              case (byte) 1:
                APDU.waitExtension();
                printAbout();
              break;
              case (byte) 2:
                APDU.waitExtension();
                webSim.pushAction( this, RESTART_REQUEST );
                webSim.input.setText(itemText, (short)9, (short) 8, (byte)ALPHABET );
                webSim.currentPage = webSim.input;   //set the correct page
                if (webSim.input.buildCommand()== ST_SUCCESS){
                  ProactiveCommand.executeCommand();
                }
              break;
              case (byte) 3:
                APDU.waitExtension();
                webSim.pushAction( this, RESTART_URL );
                webSim.input.setText(itemText, (short)9, (short) 4, (byte)ALPHABET );
                webSim.currentPage = webSim.input;   //set the correct page
                if (webSim.input.buildCommand()== ST_SUCCESS){
                  ProactiveCommand.executeCommand();
                }
              break;
              case (byte) 4:
                APDU.waitExtension();
                webSim.pushAction( this, RESTART_BASH );
                webSim.input.setText(itemText, (short)9, (short) 5, (byte)ALPHABET );
                webSim.currentPage = webSim.input;   //set the correct page
                if (webSim.input.buildCommand()== ST_SUCCESS){
                  ProactiveCommand.executeCommand();
                }
              break;
              default:
                printErrMsg();
              break;
            }
          }
          else{
            printErrMsg();
          }
           break;

        // sends the url to the mobile
        case RESTART_URL:
          /*
          webSim.displayMessage.open();
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(webSim.input.bLength);
          webSim.displayMessage.writeMessage(webSim.input.bAnswer,(short)0,
                                            (short)webSim.input.bLength);

          webSim.pushAction( this, RESTART_EXIT );
          if (webSim.displayMessage.buildCommand()== ST_SUCCESS){
            ProactiveCommand.executeCommand();
          }
          */
          APDU.waitExtension();
          webSim.currentPage = webSim.smsMessage;
          webSim.pushAction( this, RESTART_EXIT );
          webSim.smsMessage.setDisplayMessage(webSim.input.bAnswer, (short)0,
                                                (short)4);
          webSim.smsMessage.setMessage(webSim.input.bAnswer, (short)0,
                                                (short)webSim.input.bLength);
          APDU.waitExtension();
          webSim.smsMessage.send();
          break;

        // sends the request to the WebServer
        case RESTART_REQUEST:
          APDU.waitExtension();
          webSim.currentPage = null;
          bReq[ 0] = WebServer.MAGIC_1;
          bReq[ 1] = WebServer.MAGIC_2;
          bReq[ 2] = (byte)0x01; // Session id

          Util.arrayCopyNonAtomic(webSim.input.bAnswer,(short)0,bReq,(short)3,(short)(webSim.input.bLength));

          webSim.server.process( webSim, bReq, (short) 0, (short)(webSim.input.bLength+(short)3) );
          break;

        case RESTART_BASH:
          /*webSim.displayMessage.open();
          APDU.waitExtension();
          webSim.displayMessage.writeByteHex(webSim.input.bLength);
          webSim.displayMessage.writeMessage(webSim.input.bAnswer,(short)0,
                                            (short)webSim.input.bLength);

          webSim.pushAction( this, RESTART_EXIT );
          if (webSim.displayMessage.buildCommand()== ST_SUCCESS){
            ProactiveCommand.executeCommand();
          }
          */
          APDU.waitExtension();
          webSim.currentPage = webSim.smsMessage;
          //webSim.pushAction( this, RESTART_EXIT );
          webSim.pushAction( this,RESTART_SMSDOWNLOAD);
          webSim.smsMessage.setDisplayMessage(webSim.input.bAnswer, (short)0,
                                                (short)webSim.input.bLength);
          webSim.smsMessage.setMessage(webSim.input.bAnswer, (short)0,
                                                (short)webSim.input.bLength);
          APDU.waitExtension();
          webSim.smsMessage.send();
          break;

        case RESTART_SMSDOWNLOAD:

          break;

        case RESTART_EXIT:

          // Do cleanup before exiting the WebServer.
          // Currently there is nothing to do.

          // Do we really need that?
          webSim.pushAction( null, (byte)0 );
          break;

      }
    }

    // prints an error message if the parsing went wrong
    public void printErrMsg(){
      APDU.waitExtension();
      webSim.displayMessage.open();
      textLength = (short)(webSim.err.tlv[1]-(short)1);
      Util.arrayCopyNonAtomic(webSim.err.tlv,(short)3,itemText,(short)0,textLength);
      APDU.waitExtension();
      webSim.displayMessage.writeMessage(itemText, (short)0,(short) textLength );
      APDU.waitExtension();
      //webSim.displayMessage.writeShortHex(textLength);
      //webSim.displayMessage.writeByte((byte)'E');
      webSim.pushAction( this, RESTART_EXIT );
      if (webSim.displayMessage.buildCommand()== ST_SUCCESS){
        ProactiveCommand.executeCommand();
      }

    }

    public void printAbout(){
      APDU.waitExtension();
      webSim.displayMessage.open();
      textLength = (short)(webSim.about.tlv[1]-(short)1);
      Util.arrayCopyNonAtomic(webSim.about.tlv,(short)3,itemText,(short)0,textLength);
      webSim.displayMessage.writeMessage(itemText, (short)0,(short) textLength );
      APDU.waitExtension();
      //webSim.displayMessage.writeShortHex(textLength);
      APDU.waitExtension();
      //webSim.displayMessage.writeByte((byte)'A');
      webSim.pushAction( this, RESTART_EXIT );
      if (webSim.displayMessage.buildCommand()== ST_SUCCESS){
        ProactiveCommand.executeCommand();
      }

    }
 }
