import javacardx.framework.*;
import javacard.framework.*;
import sim.toolkit.*;

public class SelectItem extends Page implements GSMCharacter, ST, Constant {

  public final static short MAXITEMS = (short) 16;
  public final static short MAXITEMSIZE = (short) 32;
  final static byte  SELECTCMD = (byte) 2;

  public byte[] itemBuf = new byte[MAXITEMSIZE];

  ProactiveElement title;
  public ProactiveElement[] items = new ProactiveElement[MAXITEMS];
  short lastItem;

	public SelectItem() {
	}

  public void newSelection( byte[] titleText, short start, short len ) {
    short i;
    /*
    if (title == null) {
  	  title = new ProactiveElement(TEXT_STRING_TAG, (short) MAXITEMSIZE);
      APDU.waitExtension();
    }
    */
    lastItem = (short) 0;
    APDU.waitExtension();
    for( i=(short)0; i < MAXITEMS; i++) {
      APDU.waitExtension();
      if (items[i] != null) {
        items[i].setLength( (short) 0 );  // deactivate the proactive element
      }
    }
    APDU.waitExtension();
    /*
    if (titleText != null){
      title.setValue( titleText, start, len );
      title.setLength( len );
    } else {
      // Set title length to 0 to make the ProactiveCommand ignore this PE
      title.setLength( (short)0 );
    }
      */
  }

  public void addItem( byte[] itemText, short itemStart, short itemLen ) {
    APDU.waitExtension();
    if (items[lastItem] == null) {
      items[lastItem] = new ProactiveElement(ITEM_TAG, (short) MAXITEMSIZE);
      APDU.waitExtension();
    }
    // Set the item identifier.
    Util.arrayCopyNonAtomic( itemText, itemStart, itemBuf, (short) 1, itemLen );
    // Item identifiers must be in the range 0x01 - 0xff
    itemBuf[0] = (byte) ((byte) lastItem + (byte) 1);
    items[lastItem].setValue( itemBuf, (short) 0, MAXITEMSIZE );
    items[lastItem].setLength( (short) (itemLen + (short) 1));
    lastItem = (short)(lastItem + (short) 1);
  }

	public byte buildCommand() {
    ProactiveCommand.selectItem( SELECTCMD,   // command number
                                 (byte)0,     // no help available
                                 // FIXME: title seems to be buggy im ME simulator
                                 null, //title,
                                 items);      // items to be displayed
    return ST.SUCCESS;
	}

	public Page processResponse(){
    byte itemID;
		Page returnPage;
		returnPage = super.processResponse();
    itemBuf[0] = (byte) 0xFF;     // indicates an error
    if( ProactiveCommand.manageGeneralResult() == ST_SUCCESS) {
      itemID = ProactiveCommand.getItemIdentifier();
      //copy tlv into buffer, so we can use it in the restart methode
      Util.arrayCopyNonAtomic(items[(short)itemID].tlv, (short)0,
                                    itemBuf, (short)0,
                                    (short)(items[(short)itemID].getLength()+(short)2)) ;
    }
    return (returnPage);
	}
}

