import javacard.framework.*;
import javacardx.framework.*;
import sim.toolkit.*;

public class SendSMS extends Page {

  ProactiveElement smsTPDU;
  //ProactiveElement smsc;
  ProactiveElement dispMessage;

  // Static constant declaration
  public static final byte tp_MTI	= (byte) 0x01;      // status report request please
  public static final byte tp_MR 	= (byte) 0x00;      // no message reference
  public static final byte tp_PID	= (byte) 0x00;      // none

  //public static final byte tp_DCS	= (byte) 0xF4;    // 0xF4 = 8-bit data
  public static final byte tp_DCS	= (byte) 0x00;      // 0x00 = 7-bit GSM data

  public static final byte SMSCMD = (byte) 0x03;

  // This is the maximum length of the descriptive text displayed while sending the message.
  // Be aware! Setting this to 128 just to think it would be a good idea crashes your applet! 
  // What the hell does that mean!?
  public static final byte MAXMESSAGESIZE = (byte) 64;

  public SendSMS() {
  }

  public void setDisplayMessage( byte[] message, short start, short len ) {
    if (dispMessage == null) {
      dispMessage = new ProactiveElement(ALPHA_IDENTIFIER_TAG, MAXMESSAGESIZE);
      APDU.waitExtension();
    }
    dispMessage.setValue( message, start, len );
    dispMessage.setLength( len );
    /* if (smsc == null) {
      smsc = new ProactiveElement(ALPHA_IDENTIFIER_TAG, (short)0x10);
      APDU.waitExtension();
    } */
  }

  void setTPDU() {
    if (smsTPDU == null) {
      // FIXME: The length of the PE must be according to the SMS submit 3.40.
      // Buffer length of 170 is an upper estimation.
      smsTPDU = new ProactiveElement(SMS_TPDU_TAG, (short) 170);
      APDU.waitExtension();
    }
    smsTPDU.tlv[2] = tp_MTI;
    smsTPDU.tlv[3] = tp_MR;

    /*
    // Hard coded value of SMS gateway mobile phone:    + 49 17 15 62 24 34
    // which is in GSM notation:                    0c 91 94 71 51 26 42 43
    smsTPDU.tlv[ 4] = (byte) 0x0c;
    smsTPDU.tlv[ 5] = (byte) 0x91;
    smsTPDU.tlv[ 6] = (byte) 0x94;
    smsTPDU.tlv[ 7] = (byte) 0x71;
    smsTPDU.tlv[ 8] = (byte) 0x51;
    smsTPDU.tlv[ 9] = (byte) 0x26;
    smsTPDU.tlv[10] = (byte) 0x42;
    smsTPDU.tlv[11] = (byte) 0x43;
    */
    
    // Hard coded value of SMS gateway mobile phone:    + 42 06 03 18 31 74
    // which is in GSM notation:                    0c 91 24 60 30 81 13 47
    smsTPDU.tlv[ 4] = (byte) 0x0c;
    smsTPDU.tlv[ 5] = (byte) 0x91;
    smsTPDU.tlv[ 6] = (byte) 0x24;
    smsTPDU.tlv[ 7] = (byte) 0x60;
    smsTPDU.tlv[ 8] = (byte) 0x30;
    smsTPDU.tlv[ 9] = (byte) 0x81;
    smsTPDU.tlv[10] = (byte) 0x13;
    smsTPDU.tlv[11] = (byte) 0x47;

    smsTPDU.tlv[12] = tp_PID;
    smsTPDU.tlv[13] = tp_DCS;

    // smsTPDU.tlv[14] = length of user data, to be set in method setMessage()

    // GSM Pi indicates WebSIM SMS message
    smsTPDU.tlv[15] = (byte)0x16;
    // GSM Omega indicates Encoding in 7bit GSM packed notation
    smsTPDU.tlv[16] = (byte)0x15;

    /*
    smsc.tlv[2]  = (byte) 0x0C;
    smsc.tlv[3]  = (byte) 0x91;
    smsc.tlv[4]  = (byte) 0x24;
    smsc.tlv[5]  = (byte) 0x60;
    smsc.tlv[6]  = (byte) 0x30;
    smsc.tlv[7]  = (byte) 0x50;
    smsc.tlv[8]  = (byte) 0x02;
    smsc.tlv[9]  = (byte) 0x00;

    smsc.tlv[1]  = (byte) 0x08;
    //  24 60 30 50 02 00
    */
  }

  public void setMessage( byte[] message, short start, short len ) {
    short octets;

    setTPDU();
    Util.arrayCopyNonAtomic( message, start, smsTPDU.tlv, (short) 17, len );
    APDU.waitExtension();
    // Set TP-UDL
    //if (tp_DCS != (byte)0x00) {
      // In 8-bit encoding this is exactly "len".
		  //smsTPDU.tlv[14] = (byte)len;
      //newLen = len;
    //} else {
      // Calculate the no. of septets in the message. Overall no. of bits is (len*8).
      // No. of septets is ((len*8)/7) plus an additional septet for the remaining bits.
/*
      septets = (byte) (((short)len * (short)8) / (short)7);
      if ( (byte) (((short)len * (short)8) % (short)7) != (byte)0) {
        // Take an additional septet to catch the remaining bits.
        septets = (short) ((short)septets + (short)1);
        // Adapt the total length of the message.
        len = (short) ((short)len + (short)1);
      }
      smsTPDU.tlv[14] = (byte)septets;
*/
      // Now pack the message including the two magic characters into GSM format
      octets = ProactiveServices.packedGSM( smsTPDU.tlv, (short)15, (short) ((short)len + (short)2) );
      // The number of septets is the number of overall bits div 7. 

      smsTPDU.tlv[14] = (byte)(((short)octets * (short)8) / (short)7);
      //smsTPDU.tlv[14] = (byte)octets;
      //smsTPDU.tlv[14] = (byte)((short)len + (short)2);

      //if ( (((short)len * (short)8) % (short)7) != (byte)0) {
      //  smsTPDU.tlv[14] = (byte) ((byte)smsTPDU.tlv[14] + (byte)1);
      //}
    //  newLen = (short)smsTPDU.tlv[14];
    //}
    // Set length of whole TPDU. Header is bytes 2-13,14 which makes up 13 bytes
    // plus additional payload which is "newLen".
    APDU.waitExtension();
    smsTPDU.setLength( (short) ((short)13 + (short)octets) );
    APDU.waitExtension();
	}

  public byte buildCommand() {
    // ADDRESS = null means that ME should insert default Service Center address
    ProactiveCommand.sendShortMessage( SMSCMD, UNPACKED, dispMessage, null /* smsc */, smsTPDU );
    return ST_SUCCESS;
  }

  public void send() {
    if (buildCommand() == ST_SUCCESS) {
      ProactiveCommand.executeCommand();
    }
  }
 }
