import javacard.framework.*;
import javacardx.framework.*;
import sim.toolkit.*;

public class Support implements GSMCharacter {

  static byte[] hex = {  (byte)'0', (byte)'1', (byte)'2', (byte)'3',
                         (byte)'4', (byte)'5', (byte)'6', (byte)'7',
                         (byte)'8', (byte)'9',        A,         B,
                                C,         D,         E,         F };

  static byte[] invHex = {       F,         E,         D,        C,
                                 B,         A,  (byte)'9', (byte)'8',
                          (byte)'7', (byte)'6', (byte)'5', (byte)'4',
                          (byte)'3', (byte)'2', (byte)'1', (byte)'0'};

  public static void writeByte( byte s, byte[] dest, short index ) {
    dest[index]                       = hex[(short)((s >> 4) & 15)];
    dest[(short) (index + (short) 1)] = hex[(short) (s       & 15)];
  }

  public static void writeShort( short s, byte[] dest, short index ) {
    dest[index]                       = hex[(short)((s >> 12) & 15)];
    dest[(short) (index + (short) 1)] = hex[(short)((s >>  8) & 15)];
    dest[(short) (index + (short) 2)] = hex[(short)((s >>  4) & 15)];
    dest[(short) (index + (short) 3)] = hex[(short)( s & 15)];
  }

  public static void writeInvByte( byte s, byte[] dest, short index ) {
    dest[(short) (index + (short) 1)] = hex[(short)((s >> 4) & 15)];
    dest[index]                       = hex[(short) (s & 15)];
  }

  public static void sign(byte[] src, short offset,
                          byte[] dest, short index, short len){
    short counter;
    for (counter = offset; counter < (short)(offset + len); counter++){
      APDU.waitExtension();
      if (src[counter] >= (byte)'0' && src[counter] <= (byte)'9') {
        dest[index] = invHex[(short) (src[counter] - (byte)'0')];
      } else if (src[counter] >= A && src[counter] <= F) {
        dest[index] = invHex[(short) (src[counter] - A + (byte)10)];
      } else if (src[counter] >= a && src[counter] <= f) {
        dest[index] = invHex[(short) (src[counter] - a + (byte)10)];
      } else{
        dest[index] = src[counter]; // Just copy the illegal character
      }
      index++;
    }
  }
}

